######
#  This script allows an IBM Technology for JAVA jvm to be monitored and when the heap size exceeds a triggervalue in MB, it will 
#  perform a GENJVMDMP command on the JVM.  You can use this interactively (do not F3 to close session, or trigger job ends), or you can kick off 
#  in batch with  SBMJOB CMD(QSH CMD('/home/henderan/collectorscripts/J9MonitorTool.sh  631338/qwebadmin/admin4 50')) JOB(J9MONITOR)                               
#
#  This script only supports R610 and R710

export JOBNAME=$1
export TRIGGERVALUE=$2

CURLOC=`(pwd) 2>/dev/null`

DATE=`(date "+%m-%d-%Y")`

if test "${JOBNAME}" = ""; then
echo "Please enter the name of the JVM to monitor.  Enter the short name, or fully qualified name in number/user/name format."
read JOBNAME
ps -A | grep -i "$JOBNAME" |  grep -vi "outq" | cut -c 53-80  > /tmp/JVMJobs.txt 
JOBLIST=`cat /tmp/JVMJobs.txt`
if test "${JOBLIST}" = ""; then
     echo "There is no job ${JOBNAME} active.  Exiting tool."
     exit
fi

count=0     
echo "  "
cat  /tmp/JVMJobs.txt | while read line
do
    count=`expr $count + 1`
    echo "$count:      $line" >> /tmp/JVMJobsMenu_file.txt
done
echo " "
echo "*******************************************************"
echo " "
echo "Please select # of the JVM you wish to monitor the heap"
echo " "
cat /tmp/JVMJobsMenu_file.txt
echo " "
echo "*******************************************************"

read choice
JOBNAME=`grep "${choice}:" /tmp/JVMJobsMenu_file.txt | cut -c 9-50 `
if test "${JOBNAME}" = ""; then
   echo "Invalid selection.  Exiting tool."
   rm /tmp/JVMJobsMenu_file.txt
   exit
   fi
   echo " "
echo "You chose the JVM $JOBNAME to monitor."
rm /tmp/JVMJobsMenu_file.txt
fi



if test "${TRIGGERVALUE}" = ""; then
echo " "
echo "Please enter the trigger value in MB."
read TRIGGERVALUE
 if [ ${TRIGGERVALUE} -ge 0 ]; then
     echo "Triggervalue is valid"
     else
     echo "Triggervalue is invalid"
     exit
  fi
fi

#
echo " "
echo "Performing PRTJVMJOB JOB($JOBNAME) OPTION(*GC) "
SHORTNAME=`echo $JOBNAME | cut -d / -f3`       
system "PRTJVMJOB JOB($JOBNAME) OPTION(*GC)" > /tmp/${SHORTNAME}GCSize.txt 2> /tmp/${SHORTNAME}GCSize.txt

HEAPSIZE=`grep  "Heap in use" /tmp/${SHORTNAME}GCSize.txt | cut -c 50-58`
BREAKMEM=`grep "Internal memory" /tmp/${SHORTNAME}GCSize.txt | cut -c 50-58`

if test "${HEAPSIZE}" = ""; then
echo "The JVM $JOBNAME is not a valid JVM, or may be a classic JVM, which is not supported with this tool."
exit
fi

echo "Break memory is $BREAKMEM MBytes"
echo "Heap size is $HEAPSIZE MBytes"

while [ true ]

DIFFERENCE=`expr $TRIGGERVALUE - $HEAPSIZE` 
echo "The difference between the current Trigger value size and Heap Size is ${DIFFERENCE} MB"

do
  if [ ${HEAPSIZE} -ge ${TRIGGERVALUE} ]
  then
  echo " "
  echo "Trigger condition exists."
  echo "The heap size is currently at ${HEAPSIZE} MB"
  system "GENJVMDMP JOB($JOBNAME) TYPE(*JAVA *HEAP)"
  echo " "
  echo "Performing DSPJOB, DSPJOBLOG and PRTJVMJOB to files"
  system "SNDMSG MSG('Heap value has triggered for JVM $JOBNAME') TOUSR(*SYSOPR)"
  echo "${CURLOC}/DSPJOB${SHORTNAME}.txt"
  echo "${CURLOC}/DSPJOBLOG${SHORTNAME}.txt"
  echo "${CURLOC}/PRTJVMJOB${SHORTNAME}.txt"
  system "DSPJOB JOB($JOBNAME)"  > ${CURLOC}/DSPJOB${SHORTNAME}.txt
  system "DSPJOBLOG JOB($JOBNAME)"  > ${CURLOC}/DSPJOBLOG${SHORTNAME}.txt
  system "PRTJVMJOB JOB($JOBNAME)"  > ${CURLOC}/PRTJVMJOB${SHORTNAME}.txt
  echo "Please gather the .phd and javacore files.  The location of these files are found in ${CURLOC}/DSPJOBLOG${SHORTNAME}.txt "
  rm /tmp/${SHORTNAME}GCSize.txt
  exit
  else
  echo " "
  echo "Sleeping 30 seconds, then PRTJVMJOB"
  echo " "
  sleep 30
  system "PRTJVMJOB JOB($JOBNAME) OPTION(*GC)" > /tmp/${SHORTNAME}GCSize.txt 2> /tmp/${SHORTNAME}GCSize.txt
  date +%m%/%d%/%y%'  '%H:%M:%S  
  HEAPSIZE=`grep  "Heap in use" /tmp/${SHORTNAME}GCSize.txt | cut -c 50-58`
  BREAKMEM=`grep "Internal memory" /tmp/${SHORTNAME}GCSize.txt | cut -c 50-58`
  echo "Heap size is currently at ${HEAPSIZE} MB"
  echo "The trigger value specified is ${TRIGGERVALUE} MB"
  echo "Break memory size is currently at ${BREAKMEM} MB"
fi

done
   