######
#  This script allows an IBM Technology for JAVA jvm to be monitored and when the heap size exceeds a triggervalue in MB, it will 
#  perform a GENJVMDMP command on the JVM.  You can use this interactively (do not F3 to close session, or trigger job ends), or you can kick off 
#  in batch with  SBMJOB CMD(QSH CMD('/home/henderan/collectorscripts/J9MonitorTool.sh  631338/qwebadmin/admin4 50')) JOB(J9MONITOR)                               
#
#  This script only supports R610 and R710

export JOBNAME=$1
export TRIGGERVALUE=$2

CURLOC=`(pwd) 2>/dev/null`

DATE=`(date "+%m-%d-%Y")`

if test "${JOBNAME}" = ""; then
echo "Please enter the name of the JVM to monitor.  Enter the short name, or fully qualified name in number/user/name format."
read JOBNAME
ps -A | grep -i "$JOBNAME" |  grep -vi "outq" | cut -c 53-80  > /tmp/JVMJobs.txt 
JOBLIST=`cat /tmp/JVMJobs.txt`
if test "${JOBLIST}" = ""; then
     echo "There is no job ${JOBNAME} active.  Exiting tool."
     exit
fi

count=0     
echo "  "
cat  /tmp/JVMJobs.txt | while read line
do
    count=`expr $count + 1`
    echo "$count:      $line" >> /tmp/JVMJobsMenu_file.txt
done
echo " "
echo "*******************************************************"
echo " "
echo "Please select # of the JVM you wish to monitor the threads"
echo " "
cat /tmp/JVMJobsMenu_file.txt
echo " "
echo "*******************************************************"

read choice
JOBNAME=`grep "${choice}:" /tmp/JVMJobsMenu_file.txt | cut -c 9-50 `
if test "${JOBNAME}" = ""; then
   echo "Invalid selection.  Exiting tool."
   rm /tmp/JVMJobsMenu_file.txt
   exit
   fi
   echo " "
echo "You chose the JVM $JOBNAME to monitor."
rm /tmp/JVMJobsMenu_file.txt
fi



if test "${TRIGGERVALUE}" = ""; then
echo " "
echo "Please enter the thread count trigger value."
read TRIGGERVALUE
 if [ ${TRIGGERVALUE} -ge 0 ]; then
     echo "Triggervalue is valid"
     else
     echo "Triggervalue is invalid"
     exit
  fi
fi

#
echo " "
echo "Performing DSPJOB JOB($JOBNAME) OPTION(*RUNA) "
SHORTNAME=`echo $JOBNAME | cut -d / -f3`       
system "DSPJOB JOB($JOBNAME) OPTION(*RUNA)" > /tmp/${SHORTNAME}RunAttributes.txt 2> /tmp/${SHORTNAME}RunAttributes.txt

THREADCOUNT=`grep  "Threads . . . . " /tmp/${SHORTNAME}RunAttributes.txt | cut -c 75-80`


echo "Thread count is ${THREADCOUNT}"


while [ true ]

DIFFERENCE=`expr ${TRIGGERVALUE} - ${THREADCOUNT}` 
echo "The difference between the current Trigger value and Thread count is ${DIFFERENCE}"

do
  if [ ${THREADCOUNT} -ge ${TRIGGERVALUE} ]
  then
  echo " "
  echo "Trigger condition exists."
  echo "The thread count is currently ${THREADCOUNT}"
  echo "Performing GENJVMDMP TYPE(*JAVA *HEAP) for ${JOBNAME}.  The location of the heapdump and javacore is found in the ${CURLOC}/DSPJOBLOG${SHORTNAME}.txt "
  system "GENJVMDMP JOB($JOBNAME) TYPE(*JAVA *HEAP)"
  echo " "
  echo "Performing DSPJOB, DSPJOBLOG and PRTJVMJOB to files"
  system "SNDMSG MSG('Thread count value has triggered for JVM $JOBNAME') TOUSR(*SYSOPR)"
  echo "${CURLOC}/DSPJOB${SHORTNAME}.txt"
  echo "${CURLOC}/DSPJOBLOG${SHORTNAME}.txt"
  echo "${CURLOC}/PRTJVMJOB${SHORTNAME}.txt"
  system "DSPJOB JOB($JOBNAME)"  > ${CURLOC}/DSPJOB${SHORTNAME}.txt
  system "DSPJOBLOG JOB($JOBNAME)"  > ${CURLOC}/DSPJOBLOG${SHORTNAME}.txt
  system "PRTJVMJOB JOB($JOBNAME)"  > ${CURLOC}/PRTJVMJOB${SHORTNAME}.txt
  echo "Please gather the .phd and javacore files.  The location of these files are found in ${CURLOC}/DSPJOBLOG${SHORTNAME}.txt "
  rm /tmp/${SHORTNAME}RunAttributes.txt
  exit
  else
  echo " "
  echo "Sleeping 30 seconds, then PRTJVMJOB"
  echo " "
  sleep 30
  system "DSPJOB JOB($JOBNAME) OPTION(*RUNA)" > /tmp/${SHORTNAME}RunAttributes.txt 2> /tmp/${SHORTNAME}RunAttributes.txt
  date +%m%/%d%/%y%'  '%H:%M:%S  
  THREADCOUNT=`grep  "Threads . . . . " /tmp/${SHORTNAME}RunAttributes.txt | cut -c 75-80` 
  echo "Thread count is ${THREADCOUNT}"
  echo "The trigger value specified is ${TRIGGERVALUE} threads"
  fi

done
   